
// if you have a language other than english, do you want google to translate instead of a custom function in translations.js (ie function translate_de())
var googleTranslate=false;
var updateInterval;
var locationCode;
var useGPS;
var lastUpdated;
var useRealFeel;
var isCelsius;
var showRealFeel;
var enabled = true;
var useTrueAnimations;
var DBVersion;
var weatherDataObj;
var xmlReq = new XMLHttpRequest();
var iconWeather;
var animationComplete = false;
self = this;
self.weatherObject='';
/*! Initialize the systemDB global variable. */

 
        var shortName = 'WeatherElements';
        var version = '1.0';
        var displayName = 'Weather Elements';
        var maxSize = 65536; // in bytes
        var myDB = openDatabase(shortName, version, displayName, maxSize);

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function getLocationData(callback)
{
 
    myDB.transaction(function (transaction)
 {
        transaction.executeSql("SELECT * from files;",
            [ ],
            function (transaction, results) {
				
for (var i=0; i<results.rows.length; i++) {
                    var row = results.rows.item(i);
				  	locationCode = row['zipcodefield'];
					gpsCode = row['gpsCords'];
				  
					if(row['isCelsius'] == "true"){
						isCelsius = true;
					}else{
						isCelsius = false;
					};
				
					if(row['showRealFeel'] == "true"){
						showRealFeel = true;
					}else{
						showRealFeel = false;
					};

					if(row['useRealFeel'] == "true"){
						useRealFeel = true;
						
					}else{
						useRealFeel = false;
					};
					
					if(row['useGPS'] == "true"){
						useGPS = true;
					}else{
						useGPS = false;
					};	
					if(row['use24hour'] == "true"){
						use24hour = true;
					}else{
						use24hour = false;
					};
					if(row['useInches'] == "true"){
						useInches = true;
					}else{
						useInches = false;
					};
					language = row['language'];

					updateInterval = row['updateInterval'];
			
					weatherDataObj = row['weatherData'];

					lastUpdated = row['lastUpdated'];

					useTrueAnimations = row['useTrueAnimations'];

					DBVersion = row['DBVersion]'];
callback();

}

},
		function (transaction, error) {});
});
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function convertTime(originaltime){
if (use24hour){
var originaltime = originaltime.replace(/^\s+|\s+$/g,"").toUpperCase(); 
var originaltimelen = originaltime.length;
var tmeonly = originaltime.substring(0, originaltimelen - 3).replace(/^\s+|\s+$/g,"");
var AMPM = originaltime.substring(originaltimelen - 3, originaltimelen).replace(/^\s+|\s+$/g,"");
var finaltime;

if (AMPM == "PM")
{
var collen = tmeonly.search(":");
var tmeonlylen = tmeonly.length;
var hours = parseInt(tmeonly.substring(0, collen),10) + 12;
var minutes = tmeonly.substring(collen + 1, tmeonlylen - collen +2);
finaltime = hours + ":" + minutes;
}else{
finaltime = tmeonly;
}
return finaltime;
}else{
return originaltime;
}

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function convertPress(num)
{
    // Convert pressure to hPa or return in inHg, assuming Celsius == European == Metric System ;)
    if (isCelsius === true)
        return Math.round (num * 33.86) + " hpa";
    else
        return num + " inHg";
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function convertSpeed(num)
{
    // Convert speed to km/h or return in mph, assuming Celsius == European == Metric System ;)
    if (isCelsius === true)
        return Math.round (num * 1.609) + " kmh";
    else
        return num + " mph";
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function convertDistance(miles){
    if (isCelsius === true){
return (miles * 1.609344).toFixed(3) + " km";
    }else{
    return miles + " miles";
}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function convertInches(inches)
{
if (useInches == true){
return inches + " inches";
}else{
var mm = (inches/.0393700787).toFixed(2); 
return mm + " mm";
}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function forecastTemp()
{

            if ($('#forecastdiv').css('display')=='none') 
            {
				$('#forecastdiv').css('display','block');
				$('#iframediv').css('display','none'); 
                $('#forecastarrow').delay(1000).fadeIn(000);
            }
			
            else
		    {
			$('#forecastdiv').css('display','none');	
			$('#iframediv').css('display','block');
            $('#forecastarrow').hide();
 
	    	}

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//shows and hides the more info page
function moreInfo()
{

            if ($('#moreinfodiv').css('display')=='none') 
            {
				$('#moreinfodiv').css('display','block');
				$('#iframeDiv').css('display','none'); 
                $('#moreinfoarrow').delay(1000).fadeIn(1000);
            }
			
            else
		    {
			$('#moreinfodiv').css('display','none');	
			$('#iframeDiv').css('display','block');
            $('#moreinfoarrow').hide(); 
	    	}

}

////////////////////////////////////////////////////////////////////////////////////////////////////
//changes the details on the forecast page when you click on a different day
function changeDetail(index)
{
	$('#forecaststr').html(self.weatherObject.forecast[index].daycode);
	$('#forecastDetail').html(self.weatherObject.forecast[index].desc);
	$('.iconday').css('background-color','transparent');
	$('#iconday'+(index+1)).css('background-color','rgba(244, 244, 244, 0.6)');
	if(index == 0)
	{
		str=self.weatherObject.humidity;
		var sections=str.split("%");


		$('#daytext1').html(translateObj.rain + ": "+convertInches(self.weatherObject.forecast[0].rain) + "&nbsp;&nbsp;&nbsp;" + translateObj.snow + ": " +convertInches(self.weatherObject.forecast[0].snow) + "&nbsp;&nbsp;&nbsp;Humidity: "+parseInt(sections[0])+"%");
		
$('#forecastsunrise').html(translateObj.sunrise + ": " + convertTime(self.weatherObject.forecast[0].sunrise));

$('#forecastsunset').html(translateObj.sunset + ": " + convertTime(self.weatherObject.forecast[0].sunset));				


	} else {
		$('#daytext1').html(translateObj.rain + ": "+convertInches(self.weatherObject.forecast[index].rain) + "&nbsp;&nbsp;&nbsp;" + translateObj.snow + ": " +convertInches(self.weatherObject.forecast[index].snow));
		
$('#forecastsunrise').html(translateObj.sunrise + ": " + convertTime(self.weatherObject.forecast[index].sunrise));

$('#forecastsunset').html(translateObj.sunset + ": " + convertTime(self.weatherObject.forecast[index].sunset));			

}
}
////////////////////////////////////////////////////////////////////////////////////////////////////
//Calls the funtion in accuweather called fetchweatherdata which does the retreiving of the data from accuweather
function getWeather()
{ 
	
	// Spinning wheel while loading
      $('#alltemp').css('display','block').html("Retrieving Weather");
	if (useGPS == true){
		fetchWeatherData(dealWithWeather,locationCode,gpsCode);
	}else{
		gpsCode = "";
		fetchWeatherData(dealWithWeather,locationCode,gpsCode);
	}

}
//////////////////////////////////////////////////////////////////////////////////////////////////////
function dealWithWeather(weatherDataObj)
{
if (weatherDataObj.error != true){

		var str;
		var dummy="";
		var forecastNumber;

    
    var obj = JSON.parse(weatherDataObj)
		// Set global var
		self = this;
		self.weatherObject = obj;

		
		// Bottom divider image
		$('#slice').html('<img src="slice.png" border=0>');
		
		// Get real temperature and "real feel" temperature
		if(useRealFeel === true)
        {
			tempValue = convertTemp(obj.realFeel);
		}
        else
        {
			tempValue = convertTemp(obj.temp);
		}
		

		var Conditions = ["sun","sun","sun","sun","sun","cloud","cloud","cloud","blank","blank","fog","rain","rain","rain","thunderstorm","thunderstorm","thunderstorm","rain","snow","snow","snow","snow","snow","snow","snow","snow","blank","blank","snow","blank","blank","blank","blank","cloud","cloud","cloud","blank","cloud","rain","rain","thunderstorm","thunderstorm","snow","snow"];

		if(useTrueAnimations == "true"){
		$('#animationFrame').attr('src','Animations/'+Conditions[obj.icon]+'.html') 
		}
	
		// *******     TRANSLATE EVERYTHING   ***************************
		if(googleTranslate === false && language != 'en')
		{
			eval("translate_"+language+"();");
			obj = self.weatherObject;
			
		}
			
		// *******   END   TRANSLATE EVERYTHING  ***************************
		
		// Set the weather description
		$('#desc').html(obj.description.toLowerCase());
		
		// City from location code
		$('#city').html(obj.city);
		
		// Show big temperature
		$('#temp').html(convertTemp(obj.temp));

		// Show Sunrise
		$('#sunrise').html(translateObj.sunrise + ": " + convertTime(obj.sunrise));
		// Show sunset
		$('#sunset').html(translateObj.sunset + ": " + convertTime(obj.sunset));

		// Show Observation Time
		$('#observationTime').html(translateObj.observationtime + ": " + convertTime(obj.observationTime));
		
		// Show pressure
		$('#pressure').html(translateObj.pressure + ": " + convertPress(obj.pressure));
		// Show wind gusts
		$('#windgusts').html(translateObj.windgusts + ": " + convertSpeed(obj.windgusts));
		// Show wind speed
		$('#windspeed').html(translateObj.windspeed + ": " + convertSpeed(obj.windspeed));
		//Setup compass direction
		switch (obj.windDirection)
		{
		case "N":
			$('#compasshand').show();
			break;
		case "NNE":
			$('#compasshand').css("webkitTransform","rotate(22.5deg)");
			break;
		case "NE":
			$('#compasshand').css("webkitTransform","rotate(45deg)");
			break;
		case "ENE":
			$('#compasshand').css("webkitTransform","rotate(67.5deg)");
			break;
		case "E":
			$('#compasshand').css("webkitTransform","rotate(90deg)");
			break;
		case "ESE":
			$('#compasshand').css("webkitTransform","rotate(112.5deg)");
			break;
		case "SE":
			$('#compasshand').css("webkitTransform","rotate(135deg)");
			break;
		case "SSE":
			$('#compasshand').css("webkitTransform","rotate(157.5deg)");
			break;
		case "S":
			$('#compasshand').css("webkitTransform","rotate(180deg)");
			break;
		case "SSW":
			$('#compasshand').css("webkitTransform","rotate(202.5deg)");
			break;
		case "SW":
			$('#compasshand').css("webkitTransform","rotate(225deg)");
			break;
		case "WSW":
			$('#compasshand').css("webkitTransform","rotate(247.5deg)");
			break;
		case "W":
			$('#compasshand').css("webkitTransform","rotate(270deg)");
			break;
		case "WNW":
			$('#compasshand').css("webkitTransform","rotate(292.5deg)");
			break;
		case "NW":
			$('#compasshand').css("webkitTransform","rotate(315deg)");
			break;
		case "NNW":
			$('#compasshand').css("webkitTransform","rotate(337.5deg)");
			break;
		default:
			$('#compasshand').hide();
		}

		// Show visibility
		$('#visibility').html(translateObj.visibility + ": " + convertDistance(obj.visibility));
		// Show precipitation
		$('#precip').html(translateObj.precip + ": " + obj.precip);
		// Show uv index
		//$('#uvIndex').html(translateObj.uvIndex + ": " + obj.uvIndex);
		// Show dewpoint
		$('#dewpoint').html(translateObj.dewpoint + ": " + convertTemp(obj.dewpoint));
		// Show cloud cover
		$('#cloudCover').html(translateObj.cloudCover + ": " + obj.cloudCover);
		//Show Moon Phase
		$('#moonPhaseImg').attr('src','images/moonphases/moon'+ obj.moonPhase+".png");
		//Show Moon Text
		$('#moonText').html(obj.moonText);
		// Show all temps in main view
		dummy=translateObj.hi + ": " +convertTemp(obj.hi)+"&nbsp;&nbsp;&nbsp;&nbsp;" + translateObj.lo + ": " + convertTemp(obj.lo);
		if (showRealFeel)
         {
			dummy=dummy +"&nbsp;&nbsp;&nbsp;&nbsp;" + translateObj.real + ": " + convertTemp(obj.realFeel);
		 }
		
		$('#alltemp').html(dummy);

		
		// Set high and low temps in forecast view
		$('#day1').html(forecast(obj.forecast[0].hi,obj.forecast[0].lo));
		$('#day2').html(forecast(obj.forecast[1].hi,obj.forecast[1].lo));
		$('#day3').html(forecast(obj.forecast[2].hi,obj.forecast[2].lo));
		$('#day4').html(forecast(obj.forecast[3].hi,obj.forecast[3].lo));
		$('#day5').html(forecast(obj.forecast[4].hi,obj.forecast[4].lo));
		
		
		// Today's day title
		$('#forecaststr').html(obj.forecast[0].daycode);
		
		// Day names in forecast view
		$('#daycode1').html(obj.forecast[0].daycode);
		$('#daycode2').html(obj.forecast[1].daycode);
		$('#daycode3').html(obj.forecast[2].daycode);
		$('#daycode4').html(obj.forecast[3].daycode);
		$('#daycode5').html(obj.forecast[4].daycode);
		
		// Forecast icons for forecast view
		$('#iconday1').html("<img src=\"forecast/"+obj.forecast[0].ouricon+"small.png\" border=0 onclick=\"changeDetail(0);\">");
		$('#iconday2').html("<img src=\"forecast/"+obj.forecast[1].ouricon+"small.png\" border=0 onclick=\"changeDetail(1);\">");
		$('#iconday3').html("<img src=\"forecast/"+obj.forecast[2].ouricon+"small.png\" border=0 onclick=\"changeDetail(2);\">");
		$('#iconday4').html("<img src=\"forecast/"+obj.forecast[3].ouricon+"small.png\" border=0 onclick=\"changeDetail(3);\">");
		$('#iconday5').html("<img src=\"forecast/"+obj.forecast[4].ouricon+"small.png\" border=0 onclick=\"changeDetail(4);\">");

		
		// Set rain, snow, and humidity in main view
		str=obj.humidity;
		var sections=str.split("%");

		$('#daytext1').html(translateObj.rain + ": "+convertInches(obj.forecast[0].rain) + "&nbsp;&nbsp;&nbsp;" + translateObj.snow + ": " +convertInches(obj.forecast[0].snow) +" &nbsp;&nbsp;&nbsp;" + translateObj.humidity + ": "+parseInt(sections[0])+"%");
		// Set detailed description for today's forecast in forecast view
		$('#forecastDetail').html(obj.forecast[0].desc);
		

$('#forecastsunrise').html(translateObj.sunrise + ": " + convertTime(obj.forecast[0].sunrise));
$('#forecastsunset').html(translateObj.sunset + ": " + convertTime(obj.forecast[0].sunset));

		
		// Mini icons
		iconWeather=obj.icon;

		if(googleTranslate === true && language != 'en')
		{
				  $('body').translate('en',language);
		}
animation();

}else{

$('#desc').html("Invalid Location");
$('#desc').fadeIn(1500);
}	
	
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function animation() 
{
jQuery.preLoadImages("Icon Sets/mnidhk/"+MiniIcons[iconWeather]+"2.png", "Icon Sets/mnidhk/"+MiniIcons[iconWeather]+"1.png", "Icon Sets/mnidhk/"+MiniIcons[iconWeather]+".png");
		$('#fading2').attr('src',"Icon Sets/mnidhk/"+MiniIcons[iconWeather]+"2.png");
		$('#fading1').attr('src',"Icon Sets/mnidhk/"+MiniIcons[iconWeather]+"1.png");
	      $('#weatherIcon').attr('src',"Icon Sets/mnidhk/"+MiniIcons[iconWeather]+".png");
		
		$('#fading2').fadeIn(1500);
		$('#fading1').delay(1000).fadeIn(1500);
		$('#weatherIcon').delay(1000).fadeIn(1500);
		$('#desc,#slice,#alltemp,#temp,#minago').delay(1500).fadeIn('1500');
		$('#city,#rightarrow, #leftarrow').delay(1500).fadeIn('1500');

animationComplete = true;
getLocationData(checkMinAgo);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
(function($) {
  var cache = [];
  // Arguments are image paths relative to the current page.
  $.preLoadImages = function() {
    var args_len = arguments.length;
    for (var i = args_len; i--;) {
      var cacheImage = document.createElement('img');
      cacheImage.src = arguments[i];
      cache.push(cacheImage);
    }
  }
})(jQuery)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function convertTemp(num)
{
	// Convert temp to celsius or return in fahrenheit
	if (isCelsius === true)
		return Math.round ((num - 32) * 5 / 9) + "&deg C";
	else
		return num + "&deg F";
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function forecast(temp,templo)
{
	var dummy;
	dummy=convertTemp(temp)+"&nbsp;&nbsp;<font color=\"#BEBEBE\">" + convertTemp(templo);"</font>";
	return dummy;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Get the current time
function timeNow()
{

	var currentTime = new Date ( );
	
	var currentHours = currentTime.getHours ( );
	var currentMinutes = currentTime.getMinutes ( );
		
   // Pad the minutes and seconds with leading zeros, if required
	currentMinutes = ( currentMinutes < 10 ? "0" : "" ) + currentMinutes;
  // Pad the minutes and seconds with leading zeros, if required
  	currentHours = ( currentHours < 10 ? "0" : "" ) + currentHours;

  // Compose the string for display
  var Day = currentTime.getDate();
   Day = (  Day < 10 ? "0" : "" ) +  Day;
  var month = currentTime.getMonth()+1;
   month = (  month < 10 ? "0" : "" ) +  month;
  var Year = currentTime.getFullYear();
   

  var currentTimeString = month +"/"+ Day+"/"+Year +" " +currentHours + ":" + currentMinutes+":00";

  return currentTimeString; 	
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Check how many minutes it has been since the last update
function checkMinAgo()
{  
	date1 = new Date();
	date2 = new Date();
	diff  = new Date();
	
	date1temp = new Date(lastUpdated);
	date1.setTime(date1temp.getTime());

	date2temp = new Date(timeNow());
	date2.setTime(date2temp.getTime());

	// sets difference date to difference of first date and second date

	diff.setTime(Math.abs(date1.getTime() - date2.getTime()));

	timediff = diff.getTime();

	weeks = Math.floor(timediff / (1000 * 60 * 60 * 24 * 7));
	timediff -= weeks * (1000 * 60 * 60 * 24 * 7);

	days = Math.floor(timediff / (1000 * 60 * 60 * 24)); 
	timediff -= days * (1000 * 60 * 60 * 24);

	hours = Math.floor(timediff / (1000 * 60 * 60)); 
	timediff -= hours * (1000 * 60 * 60);

	mins = Math.floor(timediff / (1000 * 60)); 
	timediff -= mins * (1000 * 60);

	secs = Math.floor(timediff / 1000); 
	timediff -= secs * 1000;
	
	if(!lastUpdated){
	$('#minago').html("0 " + translateObj.minAgo);
	getWeather();
	}else if (((hours*60) +mins) >= updateInterval){
	myDB.transaction(function (transaction)
 {
        transaction.executeSql("UPDATE files SET weatherData = ?, lastUpdated = ?",
            [null, null],
            function (transaction, results) {},
		function (transaction, error) {});
});
	animationComplete = false;
	getWeather();
	getLocationData(checkMinAgo);
	$('#minago').html(((hours*60) +mins) + " " + translateObj.minAgo);
	}else if (animationComplete == false){
		$('#minago').html(((hours*60) +mins) + " " + translateObj.minAgo);
		dealWithWeather(weatherDataObj);
	}
	
	if (!weatherDataObj){
		setTimeout(checkMinAgo,300000);
	}else{
	$('#minago').html(mins + " " + translateObj.minAgo);	
	setTimeout(checkMinAgo,60000);
	}
}
		